using System;
using System.Data.Objects;
using System.Data.EntityClient;

namespace HooIzDat.Web.Models
{
    public partial class HooIzDatEntities : ObjectContext
    {
        public const string ConnectionString = "name=HooIzDatEntities";
        public const string ContainerName = "HooIzDatEntities";
        private const bool lazyLoadingEnabled = true;
    
        public HooIzDatEntities()
            : base(ConnectionString, ContainerName)
        {
            this.ContextOptions.LazyLoadingEnabled = lazyLoadingEnabled;
        }
    
        public HooIzDatEntities(string connectionString)
            : base(connectionString, ContainerName)
        {
            this.ContextOptions.LazyLoadingEnabled = lazyLoadingEnabled;
        }
    
        public HooIzDatEntities(EntityConnection connection)
            : base(connection, ContainerName)
        {
            this.ContextOptions.LazyLoadingEnabled = lazyLoadingEnabled;
        }
       
        public ObjectSet<Character> Characters
        {
            get { return _characters  ?? (_characters = CreateObjectSet<Character>("Characters")); }
        }
        private ObjectSet<Character> _characters;
    
        public ObjectSet<CharacterTrait> CharacterTraits
        {
            get { return _characterTraits  ?? (_characterTraits = CreateObjectSet<CharacterTrait>("CharacterTraits")); }
        }
        private ObjectSet<CharacterTrait> _characterTraits;
    
        public ObjectSet<Game> Games
        {
            get { return _games  ?? (_games = CreateObjectSet<Game>("Games")); }
        }
        private ObjectSet<Game> _games;
    
        public ObjectSet<GameState> GameStates
        {
            get { return _gameStates  ?? (_gameStates = CreateObjectSet<GameState>("GameStates")); }
        }
        private ObjectSet<GameState> _gameStates;
    
        public ObjectSet<GameTile> GameTiles
        {
            get { return _gameTiles  ?? (_gameTiles = CreateObjectSet<GameTile>("GameTiles")); }
        }
        private ObjectSet<GameTile> _gameTiles;
    
        public ObjectSet<Player> Players
        {
            get { return _players  ?? (_players = CreateObjectSet<Player>("Players")); }
        }
        private ObjectSet<Player> _players;
    
        public ObjectSet<Trait> Traits
        {
            get { return _traits  ?? (_traits = CreateObjectSet<Trait>("Traits")); }
        }
        private ObjectSet<Trait> _traits;
    
        public ObjectSet<TraitVariation> TraitVariations
        {
            get { return _traitVariations  ?? (_traitVariations = CreateObjectSet<TraitVariation>("TraitVariations")); }
        }
        private ObjectSet<TraitVariation> _traitVariations;
    }
}
