#param ([string]$Web = $(throw "Path to folder required."))

$Web = "G:\Source\Jakkaj\TechEd\HooIzDat\Web" ;

$PSScriptRoot = Split-Path -Parent -Path (Get-Item -Path $MyInvocation.MyCommand.Path).FullName ;

$SourceFile = Join-Path -Path $Web -ChildPath "Content\Site.css" ;
$MinimisedFile = Join-Path -Path $Web -ChildPath "Content\Site.min.css" ;
Remove-Item -Path $MinimisedFile -ErrorAction SilentlyContinue ;

Copy-Item -Path $SourceFile -Destination $MinimisedFile ;

$YuiAssemblyPath = Join-Path -Path $PSScriptRoot -ChildPath "Dependencies\Build\Yahoo.Yui.Compressor.dll" ;
[Void][System.Reflection.Assembly]::LoadFrom($YuiAssemblyPath) ;

[string]$CssContent = Get-Content -Path $SourceFile ;
[Yahoo.Yui.Compressor.CssCompressor]::Compress($CssContent) |
	Set-Content -Path $MinimisedFile -Encoding UTF8 ;