﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using HooIzDat.Web.Controllers;
using Rhino.Mocks;
using HooIzDat.Web.Models;

namespace Tests.Controllers
{
    [TestClass]
    public class GamesControllerTest
    {
        [TestMethod]
        public void GamesController_Join_CreatesGameTiles()
        {
            // Arrange
            var games = MockRepository.GenerateStub<IGameRepository>();
            var characters = MockRepository.GenerateStub<ICharacterRepository>();
            var game = new Game { GameID = 1, Player1 = new Player { PlayerID = 1 } };
            var gamesList = new List<Game> { game }.AsQueryable();
            games.Stub(g => g.FindPendingGames()).Return(gamesList);
            characters.Stub(c => c.FindAllCharacterIds()).Return(new[] { 1, 2, 3,4,5,6,7,8,9,10,11,12 }.AsQueryable());

            // Act
            var controller = new GamesController(games, null, characters);
            controller.CurrentPlayer = new Player { PlayerID = 2 };
            controller.Join(1);

            // Assert
            Assert.AreEqual(24, game.Tiles.Count());
        }
    }
}
